package thyyxxk.webserver.service.hutoolcache;

import cn.hutool.cache.Cache;
import cn.hutool.cache.CacheUtil;
import cn.hutool.core.util.StrUtil;
import lombok.Data;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import thyyxxk.webserver.dao.his.hutoolcache.HutoolCacheDao;

import java.util.List;

@Service
public class RelativeCache implements HutoolCacheInterface<RelativeCache.Relative> {
    private final HutoolCacheDao dao;
    private static final int CACHE_SIZE = 32;
    Cache<String, Relative> cache = CacheUtil.newLFUCache(CACHE_SIZE);

    @Data
    public static class Relative {
        private String code;
        private String name;
        private String pyCode;
        private String ybCode;
    }

    @Autowired
    public RelativeCache(HutoolCacheDao dao) {
        this.dao = dao;
    }

    @Override
    public void put(String key, Relative value) {
        if (value != null) {
            cache.put(key, value);
        }
    }

    @Override
    public Relative get(String key) {
        if (StrUtil.isBlank(key)) {
            return new Relative();
        }

        Relative relative = cache.get(key);
        if (relative == null) {
            relative = dbInfo(key);
            put(key, relative);
        }
        return relative;
    }

    @Override
    public void del(String key) {
        cache.remove(key);
    }

    @Override
    public void clear() {
        cache.clear();
    }

    public Relative dbInfo(String key) {
        return dao.selectRelative(key);
    }

    @Override
    public List<CacheAll> getAll() {
        return this.getAllUtils(cache.cacheObjIterator());
    }

    @Override
    public void refreshCache(String key) {
        put(key, dbInfo(key));
    }

    @Override
    public String getLabel() {
        return "联系人关系";
    }
}
